if(DEFINED CPP_CMAKE_B5C337C27D734312A9E0E432587F511F)
    return()
endif()
set(CPP_CMAKE_B5C337C27D734312A9E0E432587F511F 1)

include("${CMAKE_CURRENT_LIST_DIR}/common.cmake")

set(FRED_FILEMAN_PROTOBUF_PROVIDER "module" CACHE STRING "Provider of Protocol-Buffers libraray")
set_property(CACHE FRED_FILEMAN_PROTOBUF_PROVIDER PROPERTY STRINGS "module" "package")

set(FRED_FILEMAN_gRPC_PROVIDER "module" CACHE STRING "Provider of gRPC libraray")
set_property(CACHE FRED_FILEMAN_gRPC_PROVIDER PROPERTY STRINGS "module" "package")

if(FRED_FILEMAN_PROTOBUF_PROVIDER STREQUAL "module")
    if(FRED_FILEMAN_gRPC_PROVIDER STREQUAL "module")
        list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
        find_package(ProtobufCpp REQUIRED)
        find_package(GrpcCpp REQUIRED)
    else()
        find_package(gRPC REQUIRED)
        include("${CMAKE_CURRENT_LIST_DIR}/GrpcGenerateCpp.cmake")
        list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
        find_package(ProtobufCpp REQUIRED)
    endif()
else()
    find_package(Protobuf REQUIRED)
    include("${CMAKE_CURRENT_LIST_DIR}/ProtobufGenerateCpp.cmake")
    if(FRED_FILEMAN_gRPC_PROVIDER STREQUAL "module")
        list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
        find_package(GrpcCpp REQUIRED)
    else()
        find_package(gRPC REQUIRED)
        include("${CMAKE_CURRENT_LIST_DIR}/GrpcGenerateCpp.cmake")
    endif()
endif()

include_directories(${PROTOBUF_INCLUDE_DIR} ${GRPC_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

protobuf_generate_cpp(FRED_FILEMAN_PROTO_SRCS FRED_FILEMAN_PROTO_HDRS ${FRED_FILEMAN_GENERATE_INTO} ${FRED_FILEMAN_PROTO_FILES})
grpc_generate_cpp(FRED_FILEMAN_GRPC_SRCS FRED_FILEMAN_GRPC_HDRS ${FRED_FILEMAN_GENERATE_INTO} ${FRED_FILEMAN_GRPC_FILES})
